public  without sharing  class SolicitudExcepcionIncentivosFlotilla {
    
    static List<String> lMesesSolicitudesCons = new List<String>{'ENERO', 'FEBRERO', 'MARZO', 'ABRIL', 'MAYO', 'JUNIO', 'JULIO', 'AGOSTO', 'SEPTIEMBRE', 'OCTUBRE', 'NOVIEMBRE', 'DICIEMBRE'};  
        
        @AuraEnabled
        public static List<String> getMesesPoliticaIncentivos(){
            System.debug('EN TAM_SolicitCerradaFlotProgExcepcionCtrl.getMesesSolicitud...');
            //Map<String, String> lMesesSolicitudesFinal = new Map<String, String>();
            List<String> lMesesSolicitudesFinal = new List<String>();
            
            Date dtFechaActual = Date.today();
            Integer intAnioActual = dtFechaActual.year();
            Integer intMes = dtFechaActual.month() -1;
            Integer intMesIni = intMes;
            Integer intMesFin = intMesIni - 3;
            
            Integer cntIniPaso = intMesIni;
            System.debug('cntIniPaso: ' + cntIniPaso + ' intMesIni: ' + intMesIni + ' intMesFin: '  + intMesFin);
            for (Integer cntIni = intMesIni; cntIni > intMesFin; cntIni--){
                if (cntIniPaso == -1 )
                    cntIniPaso = 11;
                lMesesSolicitudesFinal.add(lMesesSolicitudesCons.get(cntIniPaso));
                cntIniPaso--;
            }
            System.debug('EN TAM_SolicitCerradaFlotProgExcepcionCtrl.getMesesSolicitud lMesesSolicitudesFinal: ' + lMesesSolicitudesFinal);
            
            //Regresa la lista de lMesesSolicitudesFinal
            return lMesesSolicitudesFinal;
            
        }
    
    
    @AuraEnabled
    public static TAM_DetallePoliticaJunction__c getPoliticaFechaCierre(String modelo, String anioModelo,String rangoPrograma,String tipoVenta, String fechaVenta){
        Boolean tipoVentaBoolean;
        Date fechaDeVenta = Date.valueOf(fechaVenta);
        Date fechaVentaMenoDosMeses = fechaDeVenta.addDays(-90);
        List<TAM_DetallePoliticaJunction__c> detallePoliticaInc = new List<TAM_DetallePoliticaJunction__c>();
        TAM_DetallePoliticaJunction__c politicaCorrespondiente = new TAM_DetallePoliticaJunction__c();
        
        if(tipoVenta == 'TFS'){
            tipoVentaBoolean = true; 
        } 
        
        if(tipoVenta == 'SIN TFS'){
            tipoVentaBoolean = false;
        }
        
        
        TAM_DetallePoliticaJunction__c politicaMenorValor = new TAM_DetallePoliticaJunction__c();
        detallePoliticaInc = [SELECT TAM_BonoLealtadDealer__c,TAM_PoliticaIncentivos__r.TAM_FinVigencia__c,TAM_BonoLealtadTMEX__c,TAM_Pago_TFS__c,TAM_PoliticaIncentivos__R.Name,TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c,TAM_BonoLealtad__c,name,TAM_IncentivoTMEX_Cash__c,TAM_IncPropuesto_Cash__c,TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c,
                              id,TAM_AnioModelo__c,TAM_Clave__c,TAM_IncDealer_Cash__c FROM TAM_DetallePoliticaJunction__c 
                              WHERE TAM_Rango__r.name =: rangoPrograma AND TAM_PoliticaIncentivos__R.recordtype.name = 'Venta Corporativa' AND TAM_PoliticaIncentivos__R.TAM_InicioVigencia__c <=: fechaDeVenta AND TAM_PoliticaIncentivos__R.TAM_FinVigencia__c >=: fechaDeVenta AND TAM_Clave__c =: modelo AND TAM_AnioModelo__c =: anioModelo AND (TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c = 'Vigente' or TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c = 'Vencida')  order by TAM_IncPropuesto_Cash__c asc];
        
        
        Decimal maxvalue ;
        if(detallePoliticaInc.size() > 0){
            maxvalue = detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;   
        }
        
        //Se calcula cual es la política con menor valor
        if(!detallePoliticaInc.isEmpty()){
            For (TAM_DetallePoliticaJunction__c i : detallePoliticaInc)
            {
                
                if(i.TAM_IncPropuesto_Cash__c < maxvalue)
                    maxvalue = i.TAM_IncPropuesto_Cash__c;   
                politicaMenorValor = i;
                break;
            } 
        }
        
        if(politicaMenorValor != null){
            return politicaMenorValor;
        }else{
            return null;
        }
        
    }  
    
    @AuraEnabled
    public static List<wrapResumenPrecio> getPoliticasHistoricas(String modelo, String anioModelo,String rangoPrograma,String tipoVenta, String fechaVenta, String mesSeleccionado){
        Boolean tipoVentaBoolean;
        Date fechaDeVenta = Date.valueOf(fechaVenta);
        Date fechaVentaMenoDosMeses = fechaDeVenta.addDays(-90);
        List<wrapResumenPrecio> listaIncentivos = new List<wrapResumenPrecio> ();
        
        
        //Logica para procesar el mes seleccionado y obtener las fechas de inicio y fecha de fin del mes
        Integer mesSeleccionadoInt = getNumeroMes(mesSeleccionado);
        Integer anioActual = date.today().year();
        Integer diasDeMes = Date.daysInMonth(anioActual, mesSeleccionadoInt);
        
        Date inicioMes = date.newInstance(anioActual, mesSeleccionadoInt, 1);
        Date finDeMes = inicioMes.addDays(diasDeMes);
        
        if(tipoVenta == 'TFS'){
            tipoVentaBoolean = true;
        }
        
        if(tipoVenta == 'SIN TFS'){
            tipoVentaBoolean = false;
        }
        
        TAM_DetallePoliticaJunction__c [] detallePoliticaInc;        
        //Consultar el registro del detalle de la politica de incentivos a partir de ID  de registro
        detallePoliticaInc = [SELECT TAM_IncPropuesto_Porcentaje__c,TAM_IncDealer_Porcentaje__c,TAM_IncentivoTMEX_Porcentaje__c,TAM_MSRP__c,TAM_BonoLealtadDealer__c,TAM_BonoLealtadTMEX__c,TAM_Pago_TFS__c,TAM_PoliticaIncentivos__R.Name,TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c,TAM_BonoLealtad__c,name,TAM_IncentivoTMEX_Cash__c,TAM_IncPropuesto_Cash__c,TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c,
                              id,TAM_AnioModelo__c,TAM_Clave__c,TAM_IncDealer_Cash__c FROM TAM_DetallePoliticaJunction__c 
                              WHERE  ((TAM_PoliticaIncentivos__R.TAM_InicioVigencia__c <=: inicioMes OR TAM_PoliticaIncentivos__R.TAM_InicioVigencia__c >=: inicioMes) AND TAM_PoliticaIncentivos__R.TAM_FinVigencia__c >=: finDeMes) AND 
                              TAM_Rango__r.name =: rangoPrograma AND  TAM_PoliticaIncentivos__R.recordtype.name = 'Venta Corporativa' AND TAM_Clave__c =: modelo AND TAM_AnioModelo__c =: anioModelo AND (TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c = 'Vigente' or TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c = 'Vencida') order by TAM_PoliticaIncentivos__R.TAM_FinVigencia__c desc ];
        
        
        if(detallePoliticaInc.size() > 0){
            for(TAM_DetallePoliticaJunction__c incentivo: detallePoliticaInc){
                if(incentivo.TAM_IncPropuesto_Porcentaje__c != null && incentivo.TAM_IncPropuesto_Cash__c == null){
                    decimal porcentajeTotal = incentivo.TAM_IncPropuesto_Porcentaje__c;
                    decimal precioVehiculo = incentivo.TAM_MSRP__c;
                    decimal descuentoCalculo = (porcentajeTotal/100)*precioVehiculo;
                    decimal precioFinal = precioVehiculo - descuentoCalculo;
                    
                    wrapResumenPrecio resumenPrecio = new wrapResumenPrecio();
                    resumenPrecio.nombrePolitica = incentivo.TAM_PoliticaIncentivos__R.Name;
                    resumenPrecio.precioPublico = incentivo.TAM_MSRP__c;
                    resumenPrecio.incentivoSeleccionado = incentivo.TAM_IncPropuesto_Cash__c;
                    resumenPrecio.incentivoPropuestoPorcentaje = incentivo.TAM_IncPropuesto_Porcentaje__c;
                    resumenPrecio.incentivoDealerPorcentaje = incentivo.TAM_IncDealer_Porcentaje__c; 
                    resumenPrecio.incentivoTMEXPorcentaje =  incentivo.TAM_IncentivoTMEX_Porcentaje__c;
                    resumenPrecio.incentivoPropuesto  = descuentoCalculo;
                    resumenPrecio.periodoPolitica =  string.valueOfGmt(incentivo.TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c);
                    resumenPrecio.pagoTFS = incentivo.TAM_Pago_TFS__c;                    
                    resumenPrecio.esPorcentaje = true;
                    resumenPrecio.idPolitica = incentivo.id;
                    resumenPrecio.precioFinal = precioFinal;
                    
                    listaIncentivos.add(resumenPrecio);
                    
                }
                
                if(incentivo.TAM_IncPropuesto_Cash__c != null){
                    decimal precioFinal = incentivo.TAM_MSRP__c - incentivo.TAM_IncPropuesto_Cash__c;
                    
                    wrapResumenPrecio resumenPrecio = new wrapResumenPrecio();
                    resumenPrecio.nombrePolitica = incentivo.TAM_PoliticaIncentivos__R.Name;
                    resumenPrecio.precioPublico = incentivo.TAM_MSRP__c;
                    resumenPrecio.incentivoSeleccionado = incentivo.TAM_IncPropuesto_Cash__c;
                    resumenPrecio.incentivoPropuesto = incentivo.TAM_IncPropuesto_Cash__c;
                    resumenPrecio.incentivoDealer = incentivo.TAM_IncDealer_Cash__c; 
                    resumenPrecio.incentivoTMEX =  incentivo.TAM_IncentivoTMEX_Cash__c;
                    resumenPrecio.periodoPolitica = string.valueOfGmt(incentivo.TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c);
                    resumenPrecio.pagoTFS = incentivo.TAM_Pago_TFS__c;
                    resumenPrecio.idPolitica = incentivo.id;
                    resumenPrecio.esPorcentaje = false;
                    resumenPrecio.precioFinal = precioFinal;
                    listaIncentivos.add(resumenPrecio);
                    
                }
            }
        }
        
        system.debug('Lista política vigente'+listaIncentivos);
        if(!listaIncentivos.isEmpty()){
            return listaIncentivos;
            
        }else{
            return listaIncentivos;
        }   
        
    }   
    
    
    @AuraEnabled
    public static List<PricebookEntry> getPreciosVIN(String modelNumber, String modelYear){
        String codigoProducto = modelNumber+modelYear;
        Date fechaHoy = system.today();
        Date fechaMenos2Meses = date.today().adddays(-90);
        List<PricebookEntry> listaPrecioObj = new List<PricebookEntry>();
        
        //Consultar el precio del Vehiculo en base a la lista de precos del dia de hoy
        List<PricebookEntry> listaPrecioVehiculo = [Select Pricebook2.FinVigencia__c,id,PrecioDealer__c,Pricebook2.Name,PrecioMayorista__c,PrecioPublico__c
                                                    ,Product2.ProductCode,Product2.Anio__c From PricebookEntry 
                                                    WHERE Pricebook2.Name != 'Standard Price Book' AND Product2.IdExternoProducto__c =: codigoProducto AND IsActive = true AND PrecioPublico__c != NULL order by Pricebook2.FinVigencia__c desc limit 3];
        
        if(!listaPrecioVehiculo.isEmpty()){
            system.debug('Lista de precio'+listaPrecioVehiculo);
            return listaPrecioVehiculo;
        }else{
            system.debug('Lista de precio vacia');
            return listaPrecioObj;
            
        }
        
        
    }
    
    
    @AuraEnabled
    public static List<wrapResumenPrecio> getPoliticasVigentesPorcentaje(String modelo, String anioModelo,String rangoPrograma,String tipoVenta){
        Boolean tipoVentaBoolean;
        
        if(tipoVenta == 'TFS'){
            tipoVentaBoolean = true;
        }
        
        if(tipoVenta == 'SIN TFS'){
            tipoVentaBoolean = false;
        }
        
        
        List<wrapResumenPrecio> listaIncentivos = new List<wrapResumenPrecio> ();
        TAM_DetallePoliticaJunction__c [] detallePoliticaInc;        
        //Consultar el registro del detalle de la politica de incentivos a partir de ID  de registro
        detallePoliticaInc = [SELECT TAM_IncPropuesto_Porcentaje__c,TAM_IncDealer_Porcentaje__c,TAM_IncentivoTMEX_Porcentaje__c,TAM_MSRP__c,TAM_BonoLealtadDealer__c,TAM_BonoLealtadTMEX__c,TAM_Pago_TFS__c,TAM_PoliticaIncentivos__R.Name,TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c,TAM_BonoLealtad__c,name,TAM_IncentivoTMEX_Cash__c,TAM_IncPropuesto_Cash__c,TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c,
                              id,TAM_AnioModelo__c,TAM_Clave__c,TAM_IncDealer_Cash__c FROM TAM_DetallePoliticaJunction__c 
                              WHERE TAM_Rango__r.name =: rangoPrograma AND  TAM_PoliticaIncentivos__R.recordtype.name = 'Venta Corporativa' AND TAM_Clave__c =: modelo AND TAM_AnioModelo__c =: anioModelo AND TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c = 'Vigente'];
        
        if(detallePoliticaInc.size() > 0){
            for(TAM_DetallePoliticaJunction__c incentivo: detallePoliticaInc){
                if(incentivo.TAM_IncPropuesto_Porcentaje__c != null){
                    decimal porcentajeTotal = incentivo.TAM_IncPropuesto_Porcentaje__c;
                    decimal precioVehiculo = incentivo.TAM_MSRP__c;
                    decimal descuentoCalculo = (porcentajeTotal/100)*precioVehiculo;
                    decimal precioFinal = precioVehiculo - descuentoCalculo;
                    
                    wrapResumenPrecio resumenPrecio = new wrapResumenPrecio();
                    resumenPrecio.nombrePolitica = incentivo.TAM_PoliticaIncentivos__R.Name;
                    resumenPrecio.precioPublico = incentivo.TAM_MSRP__c;
                    resumenPrecio.incentivoSeleccionado = incentivo.TAM_IncPropuesto_Cash__c;
                    resumenPrecio.incentivoPropuestoPorcentaje = incentivo.TAM_IncPropuesto_Porcentaje__c;
                    resumenPrecio.incentivoDealerPorcentaje = incentivo.TAM_IncDealer_Porcentaje__c; 
                    resumenPrecio.incentivoTMEXPorcentaje =  incentivo.TAM_IncentivoTMEX_Porcentaje__c;
                    resumenPrecio.incentivoPropuesto  = descuentoCalculo;
                    resumenPrecio.periodoPolitica = string.valueOfGmt(incentivo.TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c);
                    resumenPrecio.pagoTFS = incentivo.TAM_Pago_TFS__c;
                    resumenPrecio.esPorcentaje = true;
                    resumenPrecio.idPolitica = incentivo.id;
                    resumenPrecio.precioFinal = precioFinal;
                    listaIncentivos.add(resumenPrecio);
                    
                }
                
                if(incentivo.TAM_IncPropuesto_Cash__c != null){
                    decimal precioFinal = incentivo.TAM_MSRP__c - incentivo.TAM_IncPropuesto_Cash__c;
                    
                    wrapResumenPrecio resumenPrecio = new wrapResumenPrecio();
                    resumenPrecio.nombrePolitica = incentivo.TAM_PoliticaIncentivos__R.Name;
                    resumenPrecio.precioPublico = incentivo.TAM_MSRP__c;
                    resumenPrecio.incentivoSeleccionado = incentivo.TAM_IncPropuesto_Cash__c;
                    resumenPrecio.incentivoPropuesto = incentivo.TAM_IncPropuesto_Cash__c;
                    resumenPrecio.incentivoDealer = incentivo.TAM_IncDealer_Cash__c; 
                    resumenPrecio.incentivoTMEX =  incentivo.TAM_IncentivoTMEX_Cash__c;
                    resumenPrecio.periodoPolitica = string.valueOfGmt(incentivo.TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c);
                    resumenPrecio.pagoTFS = incentivo.TAM_Pago_TFS__c;
                    resumenPrecio.idPolitica = incentivo.id;
                    resumenPrecio.esPorcentaje = false;
                    resumenPrecio.precioFinal = precioFinal;
                    listaIncentivos.add(resumenPrecio);
                    
                }
            }
        }
        
        
        if(!listaIncentivos.isEmpty()){
            system.debug('Lista política vigente'+listaIncentivos);
            return listaIncentivos;
            
        }else{
            system.debug('Lista política vacia');
            return listaIncentivos;
        }   
        
    } 
    
    
    @AuraEnabled
    public static List<String> obtieneMotivosSolicitud(){
        List<String> pickListValuesList= new List<String>();
        Schema.DescribeFieldResult fieldResult = TAM_SolicitudExpecionIncentivo__c.TAM_MotivoSolicitudFlotilla__c.getDescribe();
        List<Schema.PicklistEntry> ple = fieldResult.getPicklistValues();
        for( Schema.PicklistEntry pickListVal : ple){
            pickListValuesList.add(pickListVal.getLabel());
        }   
        
        return pickListValuesList;
        
    }    
    
    @auraEnabled
    public static wrapResumenPrecio getCalculoManual (decimal precioElegido, decimal incentivoDealerManual,decimal incentivoTMEXManual){
        decimal descuentoCalculo ;
        decimal precioFinal ;
        wrapResumenPrecio resumenPrecio = new wrapResumenPrecio();
        resumenPrecio.precioPublico = precioElegido;
        resumenPrecio.incentivoTMEXPorcentaje = incentivoTMEXManual;
        resumenPrecio.incentivoDealerPorcentaje = incentivoDealerManual;
        resumenPrecio.incentivoPropuestoPorcentaje = incentivoTMEXManual + incentivoDealerManual;
        
        //Calculos de porcentajes y cantidades
        if(incentivoTMEXManual != null && incentivoDealerManual != null && precioElegido != null){
            decimal porcentajeTotal = incentivoTMEXManual + incentivoDealerManual;
            decimal precioVehiculo = precioElegido;
            descuentoCalculo = (porcentajeTotal/100)*precioVehiculo;
            precioFinal = precioVehiculo - descuentoCalculo;
        }
        
        resumenPrecio.incentivoPorcentajeTotal = descuentoCalculo;
        resumenPrecio.precioFinal = precioFinal;
        
        return resumenPrecio;
        
    }
    
    @auraEnabled
    public static wrapResumenPrecio calculoTotal (String politicaSeleccionada, decimal precioSeleccionado){
        wrapResumenPrecio resumenPrecio = new wrapResumenPrecio();
        TAM_DetallePoliticaJunction__c [] detallePoliticaInc;
        decimal precioElegido  =  precioSeleccionado;
        
        detallePoliticaInc = [SELECT TAM_IncPropuesto_Porcentaje__c,TAM_IncDealer_Porcentaje__c,TAM_IncentivoTMEX_Porcentaje__c,TAM_MSRP__c,TAM_BonoLealtadDealer__c,TAM_BonoLealtadTMEX__c,TAM_Pago_TFS__c,TAM_PoliticaIncentivos__R.Name,TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c,TAM_BonoLealtad__c,name,TAM_IncentivoTMEX_Cash__c,TAM_IncPropuesto_Cash__c,TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c,
                              id,TAM_AnioModelo__c,TAM_Clave__c,TAM_IncDealer_Cash__c FROM TAM_DetallePoliticaJunction__c 
                              WHERE Id =:politicaSeleccionada];
        
        if(detallePoliticaInc.size() > 0){
            
            resumenPrecio.nombrePolitica = detallePoliticaInc[0].TAM_PoliticaIncentivos__R.Name;
            resumenPrecio.precioPublico = precioElegido;
            resumenPrecio.incentivoPropuestoPorcentaje = detallePoliticaInc[0].TAM_IncPropuesto_Porcentaje__c;
            resumenPrecio.incentivoDealerPorcentaje = detallePoliticaInc[0].TAM_IncDealer_Porcentaje__c; 
            resumenPrecio.incentivoTMEXPorcentaje =  detallePoliticaInc[0].TAM_IncentivoTMEX_Porcentaje__c;
            resumenPrecio.incentivoSeleccionado = detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;
            resumenPrecio.incentivoPropuesto = detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;
            resumenPrecio.incentivoDealer = detallePoliticaInc[0].TAM_IncDealer_Cash__c; 
            resumenPrecio.incentivoTMEX =  detallePoliticaInc[0].TAM_IncentivoTMEX_Cash__c;
            resumenPrecio.periodoPolitica =  string.valueOfGmt(detallePoliticaInc[0].TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c);
            resumenPrecio.pagoTFS = detallePoliticaInc[0].TAM_Pago_TFS__c;
            if(detallePoliticaInc[0].TAM_IncPropuesto_Porcentaje__c != null && detallePoliticaInc[0].TAM_IncPropuesto_Cash__c == null){
                decimal porcentajeTotal = detallePoliticaInc[0].TAM_IncPropuesto_Porcentaje__c;
                decimal precioVehiculo = precioElegido;
                decimal descuentoCalculo = (porcentajeTotal/100)*precioVehiculo;
                decimal precioFinal = precioVehiculo - descuentoCalculo;
                resumenPrecio.esPorcentaje = true;   
                resumenPrecio.incentivoPorcentajeTotal = descuentoCalculo;
                resumenPrecio.precioFinal = precioFinal;
            }
            
            if(detallePoliticaInc[0].TAM_IncPropuesto_Porcentaje__c == null && detallePoliticaInc[0].TAM_IncPropuesto_Cash__c != null){
                decimal precioFinal = precioElegido - detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;
                resumenPrecio.precioFinal = precioFinal;
                resumenPrecio.esPorcentaje = false; 
            }
            
            resumenPrecio.idPolitica = detallePoliticaInc[0].id;
            
            
        }
        
        return resumenPrecio;
    }
    
    
    
    @auraEnabled
    public static wrapResumenPrecio calculoPoliticaSeleccionada (String politicaSeleccionada){
        wrapResumenPrecio resumenPrecio = new wrapResumenPrecio();
        
        List<wrapResumenPrecio> listaIncentivos = new List<wrapResumenPrecio> ();
        TAM_DetallePoliticaJunction__c [] detallePoliticaInc;        
        //Consultar el registro del detalle de la politica de incentivos a partir de ID  de registro
        detallePoliticaInc = [SELECT TAM_IncPropuesto_Porcentaje__c,TAM_IncDealer_Porcentaje__c,TAM_IncentivoTMEX_Porcentaje__c,TAM_MSRP__c,TAM_BonoLealtadDealer__c,TAM_BonoLealtadTMEX__c,TAM_Pago_TFS__c,TAM_PoliticaIncentivos__R.Name,TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c,TAM_BonoLealtad__c,name,TAM_IncentivoTMEX_Cash__c,TAM_IncPropuesto_Cash__c,TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c,
                              id,TAM_AnioModelo__c,TAM_Clave__c,TAM_IncDealer_Cash__c FROM TAM_DetallePoliticaJunction__c 
                              WHERE Id =:politicaSeleccionada];
        
        
        if(detallePoliticaInc.size() > 0){
            
            resumenPrecio.nombrePolitica = detallePoliticaInc[0].TAM_PoliticaIncentivos__R.Name;
            resumenPrecio.precioPublico = detallePoliticaInc[0].TAM_MSRP__c;
            resumenPrecio.incentivoPropuestoPorcentaje = detallePoliticaInc[0].TAM_IncPropuesto_Porcentaje__c;
            resumenPrecio.incentivoDealerPorcentaje = detallePoliticaInc[0].TAM_IncDealer_Porcentaje__c; 
            resumenPrecio.incentivoTMEXPorcentaje =  detallePoliticaInc[0].TAM_IncentivoTMEX_Porcentaje__c;
            resumenPrecio.incentivoSeleccionado = detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;
            resumenPrecio.incentivoPropuesto = detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;
            resumenPrecio.incentivoDealer = detallePoliticaInc[0].TAM_IncDealer_Cash__c; 
            resumenPrecio.incentivoTMEX =  detallePoliticaInc[0].TAM_IncentivoTMEX_Cash__c;
            resumenPrecio.periodoPolitica =  string.valueOfGmt(detallePoliticaInc[0].TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c);
            resumenPrecio.pagoTFS = detallePoliticaInc[0].TAM_Pago_TFS__c;
            if(detallePoliticaInc[0].TAM_IncPropuesto_Porcentaje__c != null && detallePoliticaInc[0].TAM_IncPropuesto_Cash__c == null){
                decimal porcentajeTotal = detallePoliticaInc[0].TAM_IncPropuesto_Porcentaje__c;
                decimal precioVehiculo = detallePoliticaInc[0].TAM_MSRP__c;
                decimal descuentoCalculo = (porcentajeTotal/100)*precioVehiculo;
                decimal precioFinal = precioVehiculo - descuentoCalculo;
                resumenPrecio.esPorcentaje = true;   
                resumenPrecio.incentivoPorcentajeTotal = descuentoCalculo;
                resumenPrecio.precioFinal = precioFinal;
            }
            
            if(detallePoliticaInc[0].TAM_IncPropuesto_Porcentaje__c == null && detallePoliticaInc[0].TAM_IncPropuesto_Cash__c != null){
                decimal precioFinal = detallePoliticaInc[0].TAM_MSRP__c - detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;
                resumenPrecio.precioFinal = precioFinal;
                resumenPrecio.esPorcentaje = false; 
            }
            
            resumenPrecio.idPolitica = detallePoliticaInc[0].id;
            
            
        }
        
        return resumenPrecio;    
    }
    
    @AuraEnabled
    public static void guardaSolicitudExcepcion(TAM_WrpSolicitudFlotillaProgramaModelos wrapSolicitud,String motivoSolicitud,String comentario, Decimal precioSolicitado, boolean incentivoManual, String politicaSeleccionada,Decimal incentivoTotalManual,Decimal incentivoDealerManual, Decimal incentivoTMEXManual,TAM_DetallePoliticaJunction__c incentivoFechaCierre, String codigoDelaer,String listaVINESIn,String fechaVenta,Boolean autorizacionDTM, String documentId){
        List<string> listaVIN = listaVINESIn.Split(',');
        Account acct = new Account();
        List<String> vinesList = new List<String>();
        List<String> datosVIN;
        
        system.debug('fecha venta'+fechaVenta);
        
        Datetime fechaVentaVIN = DateTime.valueOf(fechaVenta); 
        
        if(!listaVIN.isEmpty()){
            for(String i : listaVIN){
                System.debug('EN guardaSolicitudExcepcion VINinit: ' + i);   
            } 
        }
        
        Id recordTypeId =  Schema.SObjectType.TAM_SolicitudExpecionIncentivo__c.getRecordTypeInfosByDeveloperName().get('ExcepcionVentaCorporativa').getRecordTypeId();
        Integer numeroVINES = wrapSolicitud.lVinesSeleccionados.size();
        String  listaVINES =  wrapSolicitud.lVinesSeleccionados.toString();
        String  folioSolicitudVenta = wrapSolicitud.strFolioSolicitd;
        String  nombreCliente =  wrapSolicitud.strNombreCliente;
        String  rangoPrograma =  wrapSolicitud.strRangoPrograma;
        String  fechaVigenciaCliente = wrapSolicitud.strFechaVigencia;
        String  idExterno  = wrapSolicitud.lModelosSeleccionados[0].strIdExterno;
        String politicaFechaCierre = incentivoFechaCierre.id;
        String  tipoVentaIn;
        datosVIN = wrapSolicitud.lModelosSeleccionados[0].strNombre.split('-');
        String serie = datosVIN[0];
        String codigoModelo = datosVIN[1];
        String anioModelo = datosVIN[2];
        
        if(!wrapSolicitud.lVinesSeleccionados.isEmpty()){      
            for(TAM_WrpSolicitudFlotillaProgramaModelos.wrpVinesExcepcion i : wrapSolicitud.lVinesSeleccionados){
                vinesList.add(i.strVin);
                
            }
        }
        
        
        if(wrapSolicitud.lModelosSeleccionados[0].strTipoVenta == 'Financiamiento TFS'){
            tipoVentaIn = 'Con TFS';
            
        }else{
            tipoVentaIn = 'Sin TFS';
            
        }
        decimal incentivoCorrspTMEXCash ;
        decimal incentivoSeleccTMEXCash ;
        
        
        //Conversipon de política correspondiente a pesos
        if(politicaFechaCierre != null){
            //Se calcula el precio 
            String codigoProducto = codigoModelo+anioModelo;
            List<PricebookEntry> listaPrecioObj = new List<PricebookEntry>();
            Date fechaVINDate = fechaVentaVIN.date();
            Decimal precioCorrespondiente;
            //Consultar el precio del Vehiculo en base a la lista de precos del dia de hoy
            List<PricebookEntry> listaPrecioVehiculo = new List<PricebookEntry> ();

            List<PricebookEntry> listaPrecioVehiculoFechaReporte = [select Pricebook2.FinVigencia__c,id,PrecioDealer__c,Pricebook2.Name,PrecioMayorista__c,PrecioPublico__c
                                                        ,Product2.ProductCode,Product2.Anio__c From PricebookEntry 
                                                        WHERE Pricebook2.Name != 'Standard Price Book' AND Product2.IdExternoProducto__c =: codigoProducto AND IsActive = true AND PrecioPublico__c != NULL AND (Pricebook2.InicioVigencia__c <=: fechaVINDate and Pricebook2.FinVigencia__c >=: fechaVINDate) order by Pricebook2.FinVigencia__c desc limit 1];
            

            if(!listaPrecioVehiculoFechaReporte.isEmpty()){
                listaPrecioVehiculo = listaPrecioVehiculoFechaReporte;

            }

            if(listaPrecioVehiculoFechaReporte.isEmpty()){
                listaPrecioVehiculo = [select Pricebook2.FinVigencia__c,id,PrecioDealer__c,Pricebook2.Name,PrecioMayorista__c,PrecioPublico__c
                ,Product2.ProductCode,Product2.Anio__c From PricebookEntry 
                WHERE Pricebook2.Name != 'Standard Price Book' AND Product2.IdExternoProducto__c =: codigoProducto AND IsActive = true AND PrecioPublico__c != NULL  order by Pricebook2.FinVigencia__c desc limit 1];

            } 


            if(!listaPrecioVehiculo.isEmpty()){
                precioCorrespondiente = listaPrecioVehiculo[0].PrecioPublico__c;
            }

            TAM_DetallePoliticaJunction__c politicaCorrespondiente = [Select id,TAM_IncPropuesto_Cash__c,TAM_IncPropuesto_Porcentaje__c,TAM_IncDealer_Cash__c,
                                                                      TAM_IncDealer_Porcentaje__c,
                                                                      TAM_IncentivoTMEX_Cash__c,TAM_IncentivoTMEX_Porcentaje__c FROM TAM_DetallePoliticaJunction__c WHERE id =: politicaFechaCierre];
            
            //En porcentaje
            if(politicaCorrespondiente.TAM_IncPropuesto_Porcentaje__c != null && politicaCorrespondiente.TAM_IncPropuesto_Cash__c == null){
                incentivoCorrspTMEXCash = politicaCorrespondiente.TAM_IncentivoTMEX_Porcentaje__c * precioCorrespondiente / 100 ;
                
            }
            //En dinero
            if(politicaCorrespondiente.TAM_IncPropuesto_Porcentaje__c == null && politicaCorrespondiente.TAM_IncPropuesto_Cash__c != null){
                incentivoCorrspTMEXCash = politicaCorrespondiente.TAM_IncentivoTMEX_Cash__c ;
                
            }
            system.debug('Incentivo correspondiente TMEX Cash'+incentivoCorrspTMEXCash);
        }
        
        //Conversión de política seleccionada
        if(politicaSeleccionada != null){
            TAM_DetallePoliticaJunction__c politicaSelecc = [Select id,TAM_IncPropuesto_Cash__c,TAM_IncPropuesto_Porcentaje__c,TAM_IncDealer_Cash__c,
                                                                      TAM_IncDealer_Porcentaje__c,
                                                                      TAM_IncentivoTMEX_Cash__c,TAM_IncentivoTMEX_Porcentaje__c FROM TAM_DetallePoliticaJunction__c WHERE id =: politicaSeleccionada];
            
            //En porcentaje                                                          
            if(politicaSelecc.TAM_IncPropuesto_Porcentaje__c != null && politicaSelecc.TAM_IncPropuesto_Cash__c == null){
                incentivoSeleccTMEXCash = politicaSelecc.TAM_IncentivoTMEX_Porcentaje__c * precioSolicitado / 100 ;
                
            }
            //En dinero
            if(politicaSelecc.TAM_IncPropuesto_Porcentaje__c == null && politicaSelecc.TAM_IncPropuesto_Cash__c != null){
                incentivoSeleccTMEXCash = politicaSelecc.TAM_IncentivoTMEX_Cash__c ;
                
            }

            system.debug('Incentivo Seleccionado TMEX Cash'+incentivoSeleccTMEXCash);
            
        }

      
        // Incentivo es Manual
        if(politicaSeleccionada == null && incentivoManual == true ){
            incentivoSeleccTMEXCash = incentivoTMEXManual * precioSolicitado / 100 ;

        }
        
        //Se valida si procede a aprobación de negocio automática
        Boolean aprobAutomatica;
        if(incentivoSeleccTMEXCash <= incentivoCorrspTMEXCash){
            aprobAutomatica = true;

        }else{
            aprobAutomatica = false;

        }



        Id recordTypeIdAcc =  Schema.SObjectType.Account.getRecordTypeInfosByDeveloperName().get('Dealer').getRecordTypeId();        
        if(recordTypeIdAcc != null){
            acct = [Select id FROM Account WHERE Codigo_Distribuidor__c =: codigoDelaer AND recordtypeId =: recordTypeIdAcc limit 1];
        }
        
        //Se crea un solicitud por cada VIN
        List<TAM_SolicitudExpecionIncentivo__c> listSolExp = new  List<TAM_SolicitudExpecionIncentivo__c>();
        
        for(String i : listaVIN){
            TAM_SolicitudExpecionIncentivo__c solicitudExcepcionFleet = new TAM_SolicitudExpecionIncentivo__c();
            solicitudExcepcionFleet.TAMVIN__c = i;
            solicitudExcepcionFleet.TAM_SubmittedDate__c = fechaVentaVIN.date();
            if(autorizacionDTM == true){
                solicitudExcepcionFleet.TAM_AprobacionDM__c =  'Aprobado';
            }
            if(autorizacionDTM == false){
                solicitudExcepcionFleet.TAM_AprobacionDM__c =  'Pendiente'; 
            }
            //Aprobaciónes automáticas
            if(aprobAutomatica == true){
                solicitudExcepcionFleet.TAM_VoBo_Aprobacio__c = 'Aprobado';
                solicitudExcepcionFleet.TAM_AprobacionFinanzas__c = 'Aprobado';
                solicitudExcepcionFleet.TAM_AprobacionDM__c =  'Aprobado';
                solicitudExcepcionFleet.TAM_AprobacionAutomatica__c = true;
            }
            if(aprobAutomatica == false){
                solicitudExcepcionFleet.TAM_VoBo_Aprobacio__c = 'Pendiente';
                solicitudExcepcionFleet.TAM_AprobacionFinanzas__c = 'Pendiente';

            }
            solicitudExcepcionFleet.TAM_Distribuidor__c = acct.id;
            solicitudExcepcionFleet.TAM_NumeroVINES__c = numeroVINES;
            solicitudExcepcionFleet.RecordTypeId = recordTypeId;
            solicitudExcepcionFleet.TAM_listaVINES__c = vinesList.toString();
            solicitudExcepcionFleet.TAM_FolioVentaCorporativa__c  = folioSolicitudVenta;
            solicitudExcepcionFleet.TAM_NombreCliente__c  = nombreCliente;
            solicitudExcepcionFleet.TAM_RangoPrograma__c = rangoPrograma ;
            solicitudExcepcionFleet.TAM_FechaVigenciaCliente__c = fechaVigenciaCliente;
            solicitudExcepcionFleet.TAM_IDExterno__c = idExterno+I;
            solicitudExcepcionFleet.TAM_TipoVenta__c = tipoVentaIn;
            solicitudExcepcionFleet.TAM_Serie__c = serie;
            solicitudExcepcionFleet.TAM_Modelo__c = codigoModelo;
            solicitudExcepcionFleet.TAM_AnioModelo__c = anioModelo;
            solicitudExcepcionFleet.TAM_MotivoSolicitudFlotilla__c = MotivoSolicitud;
            solicitudExcepcionFleet.TAM_Comentario__c = comentario;
            solicitudExcepcionFleet.TAM_PrecioSolicitadoDealer__c = precioSolicitado;
            solicitudExcepcionFleet.TAM_IncentivoManual__c = incentivoManual;
            solicitudExcepcionFleet.TAM_IncentivoCorrespondienteRetail__c = politicaFechaCierre;
            solicitudExcepcionFleet.TAM_IncCorrespCashTMEX__c = incentivoCorrspTMEXCash;
            solicitudExcepcionFleet.TAM_IncSeleccCashTMEX__c = incentivoSeleccTMEXCash;
            if(incentivoManual == true){
                solicitudExcepcionFleet.TAM_TotalIncentivoManual__c = incentivoTotalManual;
                solicitudExcepcionFleet.TAM_TotalIncentivoDealerManual__c = incentivoDealerManual;
                solicitudExcepcionFleet.TAM_TotalIncentivoTMEXManual__c = incentivoTMEXManual; 
                solicitudExcepcionFleet.TAM_PoliticaSeleccionadaRetail__c = null;
                
            }
            if(incentivoManual == false)
                solicitudExcepcionFleet.TAM_PoliticaSeleccionadaRetail__c = politicaSeleccionada;
            
            listSolExp.add(solicitudExcepcionFleet);
        }
        
        try{  
            System.debug('EN guardaSolicitudExcepcion listSolExp: ' + listSolExp);        	
            List<Database.UpsertResult> dtUpsrv = Database.upsert(listSolExp, TAM_SolicitudExpecionIncentivo__c.TAM_IDExterno__c, false);
            Set<String> solicitudesCreadas = new Set<String>();			
            for (Database.UpsertResult objDtSvr : dtUpsrv){
                if(!objDtSvr.isSuccess())
                    System.debug('EN guardaSolicitudExcepcion Error a la hora de crear los reg en TAM_SolicitudExpecionIncentivo: ' + objDtSvr.getErrors()[0].getMessage());
                if(objDtSvr.isSuccess())
                    System.debug('EN guardaSolicitudExcepcion los datos del reg se actualizaron con exito ID: ' + objDtSvr.getId());
                    solicitudesCreadas.add(objDtSvr.getId());									
            }
            //Metodo que relaciona las solicitudes creadas con el documento adjunto
            List<String> listaSolicitudesCreadas =new List<String>();
            listaSolicitudesCreadas.addAll(solicitudesCreadas);
            if(documentId != null){
                relatedDocumentWithException(listaSolicitudesCreadas,documentId);   
            }    
        }catch(Exception e){
            system.debug('Error en el proceso'+e.getMessage());     
            
        }
        
        
    }
    
    public static Integer getNumeroMes(String Mes){
        Map<String,Integer> mapDeMeses = new Map<String,Integer> ();     
        mapDeMeses.put('ENERO',1);
        mapDeMeses.put('FEBRERO',2);
        mapDeMeses.put('MARZO',3);
        mapDeMeses.put('ABRIL',4);
        mapDeMeses.put('MAYO',5);
        mapDeMeses.put('JUNIO',6);
        mapDeMeses.put('JULIO',7);
        mapDeMeses.put('AGOSTO',8);
        mapDeMeses.put('SEPTIEMBRE',9);
        mapDeMeses.put('OCTUBRE',10);
        mapDeMeses.put('NOVIEMBRE',11);
        mapDeMeses.put('DICIEMBRE',12); 
        
        Integer mesNumero = mapDeMeses.get(Mes);
        
        return mesNumero;        
    }

    @AuraEnabled
    public static void deleteDocument (String documentId){
        ContentDocument[] documentRecord;
        documentRecord = [Select id from ContentDocument WHERE id =: documentId];
        if(documentRecord.size() >0){
            delete documentRecord[0];   
        }
        
    } 
    
    @AuraEnabled
    public static void relatedDocumentWithException(List<String> listaSolicitud,String documentId){        
        List<ContentDocumentLink> documentLink = new List<ContentDocumentLink>();
        if(!listaSolicitud.isEmpty()){
            for(String solicitudId : listaSolicitud){
                ContentDocumentLink cdl = New ContentDocumentLink();
                cdl.LinkedEntityId = solicitudId;
                cdl.ContentDocumentId = documentId;
                cdl.shareType = 'v';
                cdl.Visibility = 'AllUsers';
                documentLink.add(cdl);
            }
        }

        try {
            if(!documentLink.isEmpty()){
                system.debug('Lista a insertar'+documentLink);
                insert documentLink;    
    
            }
            
        } catch (Exception e) {
            system.debug('Error general'+e.getMessage());
        }
    }


    
    public class wrapResumenPrecio {
        @AuraEnabled public decimal precioPublico {get; set;}
        @AuraEnabled public decimal precioDealer {get; set;}
        @AuraEnabled public decimal incentivoSeleccionado {get; set;}
        @AuraEnabled public decimal precioFinal {get; set;}
        @AuraEnabled public decimal incentivoPropuesto {get; set;}
        @AuraEnabled public decimal incentivoDealer {get; set;}
        @AuraEnabled public decimal incentivoTMEX {get; set;}
        @AuraEnabled public decimal incentivoPropuestoPorcentaje {get; set;}
        @AuraEnabled public decimal incentivoDealerPorcentaje {get; set;}
        @AuraEnabled public decimal incentivoTMEXPorcentaje {get; set;}
        @AuraEnabled public decimal incentivoPorcentajeTotal {get; set;}
        @AuraEnabled public Boolean esPorcentaje {get; set;}
        @AuraEnabled public String nombrePolitica {get; set;}
        @AuraEnabled public String periodoPolitica {get; set;}
        @AuraEnabled public String listaPrecioVigente {get; set;}
        @AuraEnabled public Boolean pagoTFS {get; set;}
        @AuraEnabled public String idPolitica {get; set;}
        @AuraEnabled public String sTpagoTFS {get; set;}
        
    }
    
}